Package: org.apache.groovy.contracts.generation

## [Java] Class AssertStatementCreationUtility.AddAssertionCallStatementToReturnStatementVisitor

- org.apache.groovy.contracts.generation.AssertStatementCreationUtility.AddAssertionCallStatementToReturnStatementVisitor

-     public static class AssertStatementCreationUtility.AddAssertionCallStatementToReturnStatementVisitor
      extends ClassCodeVisitorSupport

  Replaces a given ReturnStatement with the appropriate assertion call statement and returns a result variable expression.

- - ### Constructor Summary

    Constructors
    Constructor and description
    `AddAssertionCallStatementToReturnStatementVisitor(ReturnStatement returnStatement, Statement assertionCallStatement)` Creates a visitor that rewrites one return statement to execute an assertion call before returning.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `protected SourceUnit` | `getSourceUnit()` This visitor is source-independent.
    `` | `public void` | `visitBlockStatement(BlockStatement block)` Rewrites the block containing the target return statement.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class ClassCodeVisitorSupport` | `addError, getSourceUnit, visitAnnotation, visitAnnotations, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClass, visitClassCodeContainer, visitClosureExpression, visitConstructor, visitConstructorOrMethod, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitProperty, visitReturnStatement, visitStatement, visitStatementAnnotations, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop`
    `class CodeVisitorSupport` | `afterSwitchCaseStatementsVisited, afterSwitchConditionExpressionVisited, visitArgumentlistExpression, visitArrayExpression, visitAssertStatement, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBlockStatement, visitBooleanExpression, visitBreakStatement, visitBytecodeExpression, visitCaseStatement, visitCastExpression, visitCatchStatement, visitClassExpression, visitClosureExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitEmptyStatement, visitExpressionStatement, visitFieldExpression, visitForLoop, visitGStringExpression, visitIfElse, visitLambdaExpression, visitListExpression, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitMethodReferenceExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitReturnStatement, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitSwitch, visitSynchronizedStatement, visitTernaryExpression, visitThrowStatement, visitTryCatchFinally, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression, visitWhileLoop`

- - ### Constructor Detail

    - #### public AddAssertionCallStatementToReturnStatementVisitor(ReturnStatement returnStatement, Statement assertionCallStatement)

      Creates a visitor that rewrites one return statement to execute an assertion call before returning.

      Parameters:
        `returnStatement` - the return statement to replace
        `assertionCallStatement` - the assertion statement to insert

  - ### Method Detail

    - #### protected SourceUnit getSourceUnit()

      This visitor is source-independent.

      Returns:
        `null`

    - #### public void visitBlockStatement(BlockStatement block)

      Rewrites the block containing the target return statement.

      Parameters:
        `block` - the block being visited